#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire100eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight1004xi           # 100  -    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight1004xi = {
                1:'-10x-19y-97z',
                2:'-10x-67y-73z',
                3:'-11x-34y-93z',
                4:'-11x-76y-62z',
                5:'-12x-20y-97z',
                6:'-12x-98y-11z',
                7:'-13x-20y-96z',
                8:'-13x-34y-92z',
                9:'-13x-67y-72z',
                10:'-15x-20y-96z',
                11:'-15x-34y-92z',
                12:'-15x-76y-62z',
                13:'-16x-20y-96z',
                14:'-17x-34y-92z',
                15:'-17x-67y-71z',
                16:'-17x-97y-10z',
                17:'-180x-85y-13z',
                18:'-18x-20y-96z',
                19:'-19x-76y-61z',
                20:'-1x-15y-98z',
                21:'-1x-31y-94z',
                22:'-20x-19y-95z',
                23:'-20x-34y-91z',
                24:'-21x-66y-71z',
                25:'-22x-19y-95z',
                26:'-22x-34y-91z',
                27:'-22x-96y-9z',
                28:'-23x-18y-95z',
                29:'-23x-75y-60z',
                30:'-24x-33y-90z',
                31:'-25x-17y-94z',
                32:'-25x-66y-70z',
                33:'-27x-17y-94z',
                34:'-27x-32y-90z',
                35:'-27x-75y-59z',
                36:'-27x-95y-8z',
                37:'-28x-16y-94z',
                38:'-28x-65y-69z',
                39:'-29x-32y-90z',
                40:'-2x-16y-98z',
                41:'-2x-98y-13z',
                42:'-30x-15y-94z',
                43:'-31x-31y-89z',
                44:'-32x-13y-93z',
                45:'-32x-64y-69z',
                46:'-32x-74y-58z',
                47:'-32x-94y-7z',
                48:'-33x-12y-93z',
                49:'-33x-30y-89z',
                50:'-35x-10y-92z',
                51:'-36x-28y-88z',
                52:'-36x-63y-68z',
                53:'-36x-72y-58z',
                54:'-36x-9y-92z',
                55:'-37x-92y-6z',
                56:'-38x-27y-88z',
                57:'-38x-7y-92z',
                58:'-39x-5y-91z',
                59:'-39x-61y-67z',
                60:'-3x-17y-98z',
                61:'-3x-32y-94z',
                62:'-3x-66y-74z',
                63:'-3x-76y-64z',
                64:'-40x-25y-87z',
                65:'-40x-3y-91z',
                66:'-40x-71y-57z',
                67:'-42x-24y-87z',
                68:'-42x-90y-5z',
                69:'-43x-60y-66z',
                70:'-44x-22y-86z',
                71:'-44x-69y-56z',
                72:'-46x-20y-86z',
                73:'-46x-58y-66z',
                74:'-47x-87y-4z',
                75:'-48x-18y-85z',
                76:'-48x-67y-55z',
                77:'-49x-15y-85z',
                78:'-50x-56y-65z',
                79:'-51x-13y-84z',
                80:'-51x-65y-54z',
                81:'-51x-85y-3z',
                82:'-53x-54y-64z',
                83:'-55x-63y-53z',
                84:'-56x-51y-63z',
                85:'-56x-82y-2z',
                86:'-59x-60y-53z',
                87:'-5x-17y-98z',
                88:'-5x-32y-94z',
                89:'-60x-49y-63z',
                90:'-60x-79y-1z',
                91:'-62x-57y-52z',
                92:'-63x-46y-62z',
                93:'-64x-76y0z',
                94:'-65x-43y-61z',
                95:'-66x-54y-51z',
                96:'-68x-40y-60z',
                97:'-68x-72y0z',
                98:'-69x-51y-50z',
                99:'-6x-18y-98z',
                100:'-6x-66y-73z',
                101:'-71x-36y-59z',
                102:'-72x-48y-49z',
                103:'-73x-33y-59z',
                104:'-75x-29y-58z',
                105:'-75x-44y-48z',
                106:'-77x-25y-57z',
                107:'-77x-40y-47z',
                108:'-79x-21y-56z',
                109:'-7x-19y-97z',
                110:'-7x-33y-93z',
                111:'-7x-76y-63z',
                112:'-7x-98y-12z',
                113:'-80x-36y-47z',
                114:'-81x-17y-55z',
                115:'-82x-13y-55z',
                116:'-82x-32y-46z',
                117:'-83x-9y-54z',
                118:'-84x-28y-45z',
                119:'-86x-24y-44z',
                120:'-87x-19y-43z',
                121:'-92x-38y-5z',
                122:'-9x-19y-97z',
                123:'-9x-34y-93z',
                124:'0x-12y-99z',
                125:'0x-13y-99z',
                126:'0x-14y-98z',
                127:'0x-30y-95z',
                128:'0x-65y-75z',
                129:'0x-75y-65z',
                130:'0x0y-99z'}
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire100eight4xi" usage = "target function for charge100eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire100eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE100EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE100EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE100EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE100EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE100EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        #  
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight1004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE100EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE100EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE100EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight1004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight1004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE100EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE100EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE100EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire100eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
           